buf_comb_n b i dl dc

   b - buffer index
   i - input signal
  dl - delay time
  dc - decay time

Comb delay line. CombN uses no interpolation, CombL uses linear
interpolation, CombC uses all pass interpolation.  All times are in
seconds.  The decay time is the time for the echoes to decay by 60
decibels. If this time is negative then the feedback coefficient
will be negative, thus emphasizing only odd harmonics at an octave
lower.

Comb used as a resonator. The resonant fundamental is equal to
reciprocal of the delay time.

> import Sound.DF

> do { n <- white_noise_m
>    ; dt <- fmap (\x -> lin_exp (x + 2.0) 1.0 2.0 0.0001 0.01) (lf_saw 0.1 0.0)
>    ; c <- buf_comb_n 0 (n * 0.1) dt 0.2
>    ; audition [b_alloc 0 44100] (out1 c) }

> do { i <- impulse 0.5 0.0
>    ; n <- white_noise_m
>    ; e <- decay (i * 0.5) 0.2
>    ; c <- buf_comb_n 0 (e * n) 0.2 3.0
>    ; audition [b_alloc 0 44100] (out1 c) }
